/*
 * (C) Copyright ParaSoft Corporation 2022.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 */

#ifndef _INTERFACE_INFO_ITERATOR_H
#define _INTERFACE_INFO_ITERATOR_H

#include "../InterfaceInfo.h"

#include <ifaddrs.h>

class InterfaceInfoIterator
{
public:
    InterfaceInfoIterator();

    ~InterfaceInfoIterator();

    bool hasNext();

    InterfaceInfo* next();

private:

    struct ifaddrs *_ifaddrs, *_ifaddrIt;
    int _sd;
    char** _prefixes;
    unsigned _numberOfCustomPrefixes;
    unsigned _numberOfAllPrefixes;

    void initializeCustomInterfacePrefixes();
    void freeCustomInterfacePrefixes();
    void fillInterfaceInfo(InterfaceInfo* result, ifaddrs *ifaddr);
    
    // Degenerate copy and assignment
    InterfaceInfoIterator(const InterfaceInfoIterator&);
    InterfaceInfoIterator& operator=(const InterfaceInfoIterator&);
};

#endif
